#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdbool.h>
#include <pthread.h>

int *tab;
int tab_len;
int sum;

void *add_func(void *parameter) {

	sum = tab[0];
	for (int i = 1; i < tab_len; i++) {
		sum += tab[i];
	}
	return NULL;
}

int main(int argc, char **argv) {
	pthread_t thread;

	if (argc <= 1) {
		fprintf(stderr, "Please specify a list of integers separated by spaces\n");
		return EXIT_FAILURE;
	}

	tab_len = argc - 1;
	tab = (int *) malloc(sizeof(int) * tab_len);
	for (int i = 0; i < tab_len; i++) {
		tab[i] = atoi(argv[i+1]);
	}

	if (pthread_create(&thread, NULL, add_func, NULL) != 0) {
		fprintf(stderr, "pthread_create failed!\n");
		return EXIT_FAILURE;
	}

	if (pthread_join(thread, NULL) != 0) {
		fprintf(stderr, "pthread_join failed!\n");
		return EXIT_FAILURE;
	}

	printf("Sum: %d\n", sum);
	free(tab);

	return EXIT_SUCCESS;
}
