#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdbool.h>
#include <pthread.h>

struct params_st {
	int *tab;
	int tab_len;
};

typedef struct params_st params_t;

void *add_func(void *param) {
	params_t *p = (params_t *) param;
	static int sum;   // ALTERNATIVE: int *sum = (int *) malloc(sizeof(int));
	sum = p->tab[0];  // ALTERNATIVE: *sum = p->tab[0]
	for (int i = 1; i < p->tab_len; i++) {
		sum += p->tab[i];
	}
	return (void*)&sum;  // ALTERNATIVE: return sum
}

int main(int argc, char **argv) {
	pthread_t thread;

	if (argc <= 1) {
		fprintf(stderr, "Please specify a list of integers separated by spaces\n");
		return EXIT_FAILURE;
	}

	params_t p;
	p.tab_len = argc - 1;
	p.tab = (int *) malloc(sizeof(int) * p.tab_len);

	for (int i = 0; i < p.tab_len; i++) {
		p.tab[i] = atoi(argv[i+1]);
	}

	if (pthread_create(&thread, NULL, add_func, &p) != 0) {
		fprintf(stderr, "pthread_create failed!\n");
		return EXIT_FAILURE;
	}

	int *sum;
	if (pthread_join(thread, (void **)&sum) != 0) {
		fprintf(stderr, "pthread_join failed!\n");
		return EXIT_FAILURE;
	}

	printf("Sum: %d\n", *sum);
	free(p.tab);
	// ALTERNATIVE: free(sum)

	return EXIT_SUCCESS;
}
