#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

// Structure pour passer les informations aux threads
typedef struct {
    int id;         // Identifiant du thread
    int N;          // Valeur maximale N
    int M;          // Nombre total de threads
    long long sum;  // Pour stocker le résultat de la somme
} ThreadData;

// Fonction exécutée par chaque thread
void* compute_sum(void* arg) {
    ThreadData* data = (ThreadData*)arg;
    data->sum = 0; // Initialiser la somme à 0

    // Calculer la somme partielle
    // Chaque thread calcule la somme des entiers de (id + 1) à N avec un pas de M
    // Thread 1 : 1, 4, 7, …
    // Thread 2 : 2, 5, 8, …
    // Thread 3 : 3, 6, 9, …
    for (int i = data->id + 1; i <= data->N; i += data->M) {

        data->sum += i;

        printf("Thread %d : %d\n", data->id, i);
    }

    pthread_exit(NULL);
}

int main(int argc, char *argv[]) {
    int N = 9; // Valeur maximale N
    int M = 3; // Nombre de threads

    pthread_t threads[M];
    ThreadData data[M];
    long  globalSum = 0;

    // Créer M threads
    for (int i = 0; i < M; i++) {
        data[i].id = i;
        data[i].N = N;
        data[i].M = M;
        pthread_create(&threads[i], NULL, compute_sum, &data[i]);
    }

    // Attendre que tous les threads aient terminé
    for (int i = 0; i < M; i++) {
        pthread_join(threads[i], NULL);

        globalSum += data[i].sum; // Ajouter la somme partielle au total
    }

    // Afficher le résultat
    printf("La somme des entiers de 1 à %d avec %d threads est : %lld\n", N, M, globalSum);

    return 0;
}
